clear all;
close all;

baseSpeckledimension = 84;
weight = window2(baseSpeckledimension,baseSpeckledimension,@hann);    % window function
TruePSF = imread('Digit3_speckle.tiff');
TruePSF = mat2gray(double(TruePSF));
TruePSF = flip(TruePSF,1);
%     SpeckleData = wiener2(SpeckleData,[2 2]);
[N_Speckle_1,N_Speckle_2] = size(TruePSF);
%% filter begin
TruePSF_FFT = fftshift(fft2((TruePSF)));
LowPass_Filter = zeros(N_Speckle_1,N_Speckle_2);
Filter_Length = 40;
LowPass_Filter((floor(N_Speckle_1/2)-Filter_Length):(floor(N_Speckle_1/2)+Filter_Length-1),(floor(N_Speckle_2/2)-Filter_Length):(floor(N_Speckle_2/2)+Filter_Length-1)) = 1;
TruePSF_FFT = TruePSF_FFT.*LowPass_Filter;
TruePSF_LowPassVer = abs(ifft2(ifftshift(TruePSF_FFT)));
TruePSF_New = TruePSF./TruePSF_LowPassVer;
h = fspecial('gaussian',[4 4],0.5);
TruePSF_new = imfilter(TruePSF_New,h,'replicate');
TruePSF_new = TruePSF_new(1070:1570,950:1450);     % !!!!!  PD_Data10 center part

% Crop the speckles
[N_Speckle_1,N_Speckle_2] = size(TruePSF_new);
% [N_Speckle_1,N_Speckle_2] = size(SpeckleData);
crop = N_Speckle_1-(2*baseSpeckledimension);  % select the number of groups for average
SpeckleUse1 = N_Speckle_1-crop;
SpeckleUse2 = N_Speckle_2-crop;


SpeckleDataCrop = TruePSF_new(round(N_Speckle_1/2)+(-SpeckleUse1/2:(SpeckleUse1/2-1)),round(N_Speckle_2/2)+(-SpeckleUse2/2:(SpeckleUse2/2-1)));
figure(3);imshow(SpeckleDataCrop,[]);colormap hot;colorbar;
  

% dividing and storing subimage
overlap_ratio = 0;
num_sqrt_1 = floor(1+(SpeckleUse1-baseSpeckledimension)/((1-overlap_ratio)*baseSpeckledimension));
num_sqrt_2 = floor(1+(SpeckleUse2-baseSpeckledimension)/((1-overlap_ratio)*baseSpeckledimension));
num = num_sqrt_1*num_sqrt_2;
store_subimage = cell(num_sqrt_1,num_sqrt_2);
subimage_FFT_sum = zeros(baseSpeckledimension,baseSpeckledimension);
totalFrame = 0;
Group = 0;
ReconStore = cell(num);
ReconMultiframe = 0;

for p = 1:num_sqrt_1
    for q = 1:num_sqrt_2
        Group = Group+1;
        store_subimage{p,q} = (SpeckleDataCrop((uint16((p-1)*(1-overlap_ratio)*baseSpeckledimension+1):uint16(baseSpeckledimension*p-overlap_ratio*(p-1)*baseSpeckledimension)),...
            (uint16((q-1)*(1-overlap_ratio)*baseSpeckledimension+1):uint16(baseSpeckledimension*q-overlap_ratio*(q-1)*baseSpeckledimension))));
        store_subimage{p,q} = store_subimage{p,q}.*weight;
        filename = strcat('PSF_estimation_Speckle(6)_G',num2str(Group),'.mat');   % Estimated sub-PSF via phase-diversity
        Estimated_PSF = load(filename);
        Estimated_PSF = Estimated_PSF.PSF1_estimation;
        Recon = deconvlucy(store_subimage{p,q},Estimated_PSF,50);
        ReconStore{Group} = Recon;
        figure;imshow(mat2gray(Recon),[]);colormap hot;colorbar;
    end
end

for i = 2:num
    ReconMultiframe = ReconMultiframe+ReconStore{i};
end

ReconMultiframe = ReconMultiframe/(num-1);
figure;imshow(mat2gray(ReconMultiframe),[]);colormap hot;colorbar;


